#### Akaike and Schwartz Information Criterion for AR models with and without intercept


ols_fit <- function(x,y){
  x <- as.matrix(x);
  y <- as.vector(y);
  q <- qr(x);
  res <- as.vector(qr.resid(q,y));
  fitted <- y-res;
  return(list(fit=fitted,res=res));
}


ar_seq <- function(x,mp){
  i=1;
  pval=1;
  while(i <=mp & pval>0.05){
    aux <- embed(x,(mp+2-i));
    y <- aux[,1];
    xall <- aux[,-1]; # this is correct
    pval=summary(lm(aux[,1]~aux[,-1]))$coef[mp+2-i,4];
    #print(pval);
    i=i+1;
  }
  if(pval<=0.05){
      return(lag=mp-i+2);
  }else{
    return(0);
  }
}